Liferay.Loader.define("frontend-taglib-clay@6.6.5/Link", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/icon', '@frontend-taglib-clay$clayui/link', 'frontend-taglib-clay$classnames', 'frontend-js-react-web$react'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = Link;

    var _icon = _interopRequireDefault(require("@frontend-taglib-clay$clayui/icon"));

    var _link = _interopRequireDefault(require("@frontend-taglib-clay$clayui/link"));

    var _classnames = _interopRequireDefault(require("frontend-taglib-clay$classnames"));

    var _react = _interopRequireDefault(require("frontend-js-react-web$react"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _extends() {
      _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = arguments[i];for (var key in source) {
            if (Object.prototype.hasOwnProperty.call(source, key)) {
              target[key] = source[key];
            }
          }
        }return target;
      };return _extends.apply(this, arguments);
    }

    function _objectWithoutProperties(source, excluded) {
      if (source == null) return {};var target = _objectWithoutPropertiesLoose(source, excluded);var key, i;if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);for (i = 0; i < sourceSymbolKeys.length; i++) {
          key = sourceSymbolKeys[i];if (excluded.indexOf(key) >= 0) continue;if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;target[key] = source[key];
        }
      }return target;
    }

    function _objectWithoutPropertiesLoose(source, excluded) {
      if (source == null) return {};var target = {};var sourceKeys = Object.keys(source);var key, i;for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];if (excluded.indexOf(key) >= 0) continue;target[key] = source[key];
      }return target;
    }

    function Link(_ref) {
      var _additionalProps = _ref.additionalProps,
          _componentId = _ref.componentId,
          cssClass = _ref.cssClass,
          icon = _ref.icon,
          label = _ref.label,
          _locale = _ref.locale,
          _portletId = _ref.portletId,
          _portletNamespace = _ref.portletNamespace,
          otherProps = _objectWithoutProperties(_ref, ["additionalProps", "componentId", "cssClass", "icon", "label", "locale", "portletId", "portletNamespace"]);

      return (/*#__PURE__*/_react.default.createElement(_link.default, _extends({
          className: cssClass
        }, otherProps), icon && /*#__PURE__*/_react.default.createElement("span", {
          className: (0, _classnames.default)('inline-item', {
            'inline-item-before': label
          })
        }, /*#__PURE__*/_react.default.createElement(_icon.default, {
          symbol: icon
        })), label)
      );
    }
    //# sourceMappingURL=Link.js.map
  }
});
//# sourceMappingURL=Link.js.map