Liferay.Loader.define("layout-admin-web@4.0.122/js/breadcrumbs/Breadcrumbs", ['module', 'exports', 'require', 'frontend-js-react-web$react', './BreadcrumbsItem'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    var _react = _interopRequireDefault(require("frontend-js-react-web$react"));

    var _BreadcrumbsItem = _interopRequireDefault(require("./BreadcrumbsItem"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    var Breadcrumbs = function Breadcrumbs(_ref) {
      var entries = _ref.entries;
      return (/*#__PURE__*/_react.default.createElement("ol", {
          className: "breadcrumb"
        }, entries.map(function (entry, index) {
          return (/*#__PURE__*/_react.default.createElement(_BreadcrumbsItem.default, {
              active: index === entries.length - 1,
              key: entry.url,
              title: entry.title,
              url: entry.url
            })
          );
        }))
      );
    };

    var _default = Breadcrumbs;
    exports.default = _default;
    //# sourceMappingURL=Breadcrumbs.js.map
  }
});
//# sourceMappingURL=Breadcrumbs.js.map