Liferay.Loader.define("frontend-taglib-clay@6.6.5/data_set_display/data_renderers/BooleanRenderer", ['module', 'exports', 'require', 'frontend-taglib-clay$prop-types'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    var _propTypes = _interopRequireDefault(require("frontend-taglib-clay$prop-types"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    function BooleanRenderer(props) {
      var _props$options, _props$options2;

      if (typeof props.value !== 'boolean') {
        return null;
      }

      return props.value ? ((_props$options = props.options) === null || _props$options === void 0 ? void 0 : _props$options.trueLabel) || Liferay.Language.get('yes') : ((_props$options2 = props.options) === null || _props$options2 === void 0 ? void 0 : _props$options2.falseLabel) || Liferay.Language.get('no');
    }

    BooleanRenderer.propTypes = {
      options: _propTypes.default.shape({
        falseLabel: _propTypes.default.string,
        trueLabel: _propTypes.default.string
      }),
      value: _propTypes.default.bool
    };
    var _default = BooleanRenderer;
    exports.default = _default;
    //# sourceMappingURL=BooleanRenderer.js.map
  }
});
//# sourceMappingURL=BooleanRenderer.js.map