Liferay.Loader.define("frontend-taglib-clay@6.6.5/data_set_display/management_bar/components/CreationMenu", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/button', '@frontend-taglib-clay$clayui/drop-down', 'frontend-taglib-clay$prop-types', 'frontend-js-react-web$react', '../../DataSetDisplayContext', '../../utilities/actionItems/index'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    var _button = require("@frontend-taglib-clay$clayui/button");

    var _dropDown = _interopRequireDefault(require("@frontend-taglib-clay$clayui/drop-down"));

    var _propTypes = _interopRequireDefault(require("frontend-taglib-clay$prop-types"));

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _DataSetDisplayContext = _interopRequireDefault(require("../../DataSetDisplayContext"));

    var _index = require("../../utilities/actionItems/index");

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    function CreationMenu(_ref) {
      var primaryItems = _ref.primaryItems;

      var _useState = (0, _react.useState)(false),
          _useState2 = _slicedToArray(_useState, 2),
          active = _useState2[0],
          setActive = _useState2[1];

      var dataSetContext = (0, _react.useContext)(_DataSetDisplayContext.default);
      return (primaryItems === null || primaryItems === void 0 ? void 0 : primaryItems.length) > 0 && /*#__PURE__*/_react.default.createElement("ul", {
        className: "navbar-nav"
      }, /*#__PURE__*/_react.default.createElement("li", {
        className: "nav-item"
      }, primaryItems.length > 1 ? /*#__PURE__*/_react.default.createElement(_dropDown.default, {
        active: active,
        onActiveChange: setActive,
        trigger: /*#__PURE__*/_react.default.createElement(_button.ClayButtonWithIcon, {
          symbol: "plus"
        })
      }, /*#__PURE__*/_react.default.createElement(_dropDown.default.ItemList, null, primaryItems.map(function (item, i) {
        return (/*#__PURE__*/_react.default.createElement(_dropDown.default.Item, {
            key: i,
            onClick: function onClick(event) {
              event.preventDefault();
              setActive(false);
              (0, _index.triggerAction)(item, dataSetContext);
            }
          }, item.label)
        );
      }))) : /*#__PURE__*/_react.default.createElement(_button.ClayButtonWithIcon, {
        onClick: function onClick() {
          return (0, _index.triggerAction)(primaryItems[0], dataSetContext);
        },
        symbol: "plus"
      })));
    }

    var _default = CreationMenu;
    exports.default = _default;
    //# sourceMappingURL=CreationMenu.js.map
  }
});
//# sourceMappingURL=CreationMenu.js.map